package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.WFUser;
import com.sa.ibiz.demo.demo.domain.WFUser;
import com.sa.ibiz.demo.demo.domain.WFWorkflow;

/**
 * 实体[WFUserAssist] 数据对象
 */
@TableName(value = "T_SRFWFUSERASSIST",resultMap = "WFUserAssistResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WFUserAssist extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFUser wfmajoruser;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFUser wfminoruser;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFWorkflow wfworkflow;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String memo;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String wfmajoruserid;
    @TableField(exist = false)//逻辑属性
    private String wfmajorusername;
    private String wfminoruserid;
    @TableField(exist = false)//逻辑属性
    private String wfminorusername;
    private String wfstep;
    @TableId(value= "wfuserassistid",type=IdType.UUID)//指定主键生成策略
    private String wfuserassistid;
    private String wfuserassistname;
    private String wfworkflowid;
    @TableField(exist = false)//逻辑属性
    private String wfworkflowname;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[工作流用户]
     *  @param wfmajoruserid
     */
    public void setWfmajoruserid(String wfmajoruserid){
        if(StringUtils.isEmpty(wfmajoruserid))
            wfmajoruserid=null;
        this.wfmajoruserid = wfmajoruserid;
        this.set("wfmajoruseriddirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户]
     */
    public String getWfmajoruserid(){
        return this.wfmajoruserid;
    }
    /**
     *  重置属性值[工作流用户]
     */
    public void resetWfmajoruserid(){
        this.set("wfmajoruseriddirtyflag",false);
        this.wfmajoruserid = null;
    }
    /**
     *  设置属性值[工作流用户]
     *  @param wfmajorusername
     */
    public void setWfmajorusername(String wfmajorusername){
        if(StringUtils.isEmpty(wfmajorusername))
            wfmajorusername=null;
        this.wfmajorusername = wfmajorusername;
        this.set("wfmajorusernamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户]
     */
    public String getWfmajorusername(){
        return this.wfmajorusername;
    }
    /**
     *  重置属性值[工作流用户]
     */
    public void resetWfmajorusername(){
        this.set("wfmajorusernamedirtyflag",false);
        this.wfmajorusername = null;
    }
    /**
     *  设置属性值[工作流代办用户]
     *  @param wfminoruserid
     */
    public void setWfminoruserid(String wfminoruserid){
        if(StringUtils.isEmpty(wfminoruserid))
            wfminoruserid=null;
        this.wfminoruserid = wfminoruserid;
        this.set("wfminoruseriddirtyflag",true);
    }
    /**
     *  获取属性值[工作流代办用户]
     */
    public String getWfminoruserid(){
        return this.wfminoruserid;
    }
    /**
     *  重置属性值[工作流代办用户]
     */
    public void resetWfminoruserid(){
        this.set("wfminoruseriddirtyflag",false);
        this.wfminoruserid = null;
    }
    /**
     *  设置属性值[工作流代办用户]
     *  @param wfminorusername
     */
    public void setWfminorusername(String wfminorusername){
        if(StringUtils.isEmpty(wfminorusername))
            wfminorusername=null;
        this.wfminorusername = wfminorusername;
        this.set("wfminorusernamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流代办用户]
     */
    public String getWfminorusername(){
        return this.wfminorusername;
    }
    /**
     *  重置属性值[工作流代办用户]
     */
    public void resetWfminorusername(){
        this.set("wfminorusernamedirtyflag",false);
        this.wfminorusername = null;
    }
    /**
     *  设置属性值[代办步骤]
     *  @param wfstep
     */
    public void setWfstep(String wfstep){
        if(StringUtils.isEmpty(wfstep))
            wfstep=null;
        this.wfstep = wfstep;
        this.set("wfstepdirtyflag",true);
    }
    /**
     *  获取属性值[代办步骤]
     */
    public String getWfstep(){
        return this.wfstep;
    }
    /**
     *  重置属性值[代办步骤]
     */
    public void resetWfstep(){
        this.set("wfstepdirtyflag",false);
        this.wfstep = null;
    }
    /**
     *  设置属性值[工作流用户代办标识]
     *  @param wfuserassistid
     */
    public void setWfuserassistid(String wfuserassistid){
        if(StringUtils.isEmpty(wfuserassistid))
            wfuserassistid=null;
        this.wfuserassistid = wfuserassistid;
        this.set("wfuserassistiddirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户代办标识]
     */
    public String getWfuserassistid(){
        return this.wfuserassistid;
    }
    /**
     *  重置属性值[工作流用户代办标识]
     */
    public void resetWfuserassistid(){
        this.set("wfuserassistiddirtyflag",false);
        this.wfuserassistid = null;
    }
    /**
     *  设置属性值[工作流用户代办名称]
     *  @param wfuserassistname
     */
    public void setWfuserassistname(String wfuserassistname){
        if(StringUtils.isEmpty(wfuserassistname))
            wfuserassistname=null;
        this.wfuserassistname = wfuserassistname;
        this.set("wfuserassistnamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户代办名称]
     */
    public String getWfuserassistname(){
        return this.wfuserassistname;
    }
    /**
     *  重置属性值[工作流用户代办名称]
     */
    public void resetWfuserassistname(){
        this.set("wfuserassistnamedirtyflag",false);
        this.wfuserassistname = null;
    }
    /**
     *  设置属性值[工作流]
     *  @param wfworkflowid
     */
    public void setWfworkflowid(String wfworkflowid){
        if(StringUtils.isEmpty(wfworkflowid))
            wfworkflowid=null;
        this.wfworkflowid = wfworkflowid;
        this.set("wfworkflowiddirtyflag",true);
    }
    /**
     *  获取属性值[工作流]
     */
    public String getWfworkflowid(){
        return this.wfworkflowid;
    }
    /**
     *  重置属性值[工作流]
     */
    public void resetWfworkflowid(){
        this.set("wfworkflowiddirtyflag",false);
        this.wfworkflowid = null;
    }
    /**
     *  设置属性值[工作流]
     *  @param wfworkflowname
     */
    public void setWfworkflowname(String wfworkflowname){
        if(StringUtils.isEmpty(wfworkflowname))
            wfworkflowname=null;
        this.wfworkflowname = wfworkflowname;
        this.set("wfworkflownamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流]
     */
    public String getWfworkflowname(){
        return this.wfworkflowname;
    }
    /**
     *  重置属性值[工作流]
     */
    public void resetWfworkflowname(){
        this.set("wfworkflownamedirtyflag",false);
        this.wfworkflowname = null;
    }
     /**
     *  获取主实体关联数据[WFUser]
     */
    public WFUser getWfmajoruser() {
        return wfmajoruser;
    }
    /**
     *  设置主实体关联数据[WFUser]
     */
    public void setWfmajoruser(WFUser wfmajoruser) {
        this.wfmajoruser = wfmajoruser;
    }

     /**
     *  获取主实体关联数据[WFUser]
     */
    public WFUser getWfminoruser() {
        return wfminoruser;
    }
    /**
     *  设置主实体关联数据[WFUser]
     */
    public void setWfminoruser(WFUser wfminoruser) {
        this.wfminoruser = wfminoruser;
    }

     /**
     *  获取主实体关联数据[WFWorkflow]
     */
    public WFWorkflow getWfworkflow() {
        return wfworkflow;
    }
    /**
     *  设置主实体关联数据[WFWorkflow]
     */
    public void setWfworkflow(WFWorkflow wfworkflow) {
        this.wfworkflow = wfworkflow;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetMemo();
        resetUpdatedate();
        resetUpdateman();
        resetWfmajoruserid();
        resetWfmajorusername();
        resetWfminoruserid();
        resetWfminorusername();
        resetWfstep();
        resetWfuserassistid();
        resetWfuserassistname();
        resetWfworkflowid();
        resetWfworkflowname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WFUserAssist copyTo(WFUserAssist targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WFUserAssist.class, WFUserAssist.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWfuserassistid();
		return targetEntity;
	}
}